/*
 * SurfaceMeshGeneralMCABoundedMulti.h
 *
 *  Created on: Jun 14, 2012
 *      Author: mjackson
 */

#ifndef SURFACEMESHGENERALMCABOUNDEDMULTI_H_
#define SURFACEMESHGENERALMCABOUNDEDMULTI_H_

#include "SurfaceMeshStructs.h"

#include <string>



namespace CMUSurfaceMeshing2
{

// function prototypes...
int execute(MeshParameters* mp);

voxel* initialize_micro_from_dx_file ( int &xDim, int &yDim, int &zDim,
                        double dx, double dy, double dz,
                        const std::string ifn);
void get_neighbor_list (neighbor *n, int ns, int nsp, int xDim, int yDim, int zDim);

#if 0
void read_edge_neighspin_table (int eT2d[20][8], int nsT2d[20][8]);
#endif

void initialize_nodes (voxel *p, node *v, int ns, double dx, double dy, double dz);
void initialize_squares (neighbor *n, face *sq, int ns, int nsp);
int  get_number_fEdges (face *sq, voxel *p, neighbor *n, int eT2d[20][8], int ns);
void get_nodes_fEdges (face *sq, voxel *p, neighbor *n, node *v, segment *e,
          int eT2d[20][8], int nsT2d[20][8], int ns, int nsp, int xDim);
int  get_square_index (int tns[4]);
int  treat_anomaly (int tnst[4], voxel *p1, neighbor *n1, int sqid);
void get_nodes (int cst, int ord, int nidx[2], int *nid, int nsp1, int xDim1);
void get_spins (voxel *p1, int cst, int ord, int pID[2], int *pSpin, int nsp1, int xDim1);
int  get_number_triangles (voxel *p, face *sq, node *v, segment *e,
         int ns, int nsp, int xDim);
int  get_number_case0_triangles (int *afe, node *v1, segment *e1, int nfedge);
int  get_number_case2_triangles (int *afe, node *v1, segment *e1, int nfedge, int *afc, int nfctr);
int  get_number_caseM_triangles (int *afe, node *v1, segment *e1, int nfedge, int *afc, int nfctr);
int  get_triangles (voxel *p, patch *t, face *sq, node *v, segment *e,
        neighbor *n, int ns, int nsp, int xDim);
void get_case0_triangles (patch *t1, int *afe, node *v1, segment *e1,
        int nfedge, int tin, int *tout, double tcrd1[3], double tcrd2[3], int mcid);
void get_case2_triangles (patch *t1, int *afe, node *v1, segment *e1,
        int nfedge, int *afc, int nfctr, int tin, int *tout, double tcrd1[3], double tcrd2[3], int mcid);
void get_caseM_triangles (patch *t1, int *afe, node *v1, segment *e1,
        int nfedge, int *afc, int nfctr, int tin, int *tout, int ccn, double tcrd1[3], double tcrd2[3], int mcid);
void find_edgePlace(double tvcrd1[3], double tvcrd2[3], double tvcrd3[3], int tw[3],
        double xh, double xl, double yh, double yl, double zh, double zl);
int get_number_unique_inner_edges(patch *t, int nT);
void get_unique_inner_edges(patch *t, isegment *ie, int nT, int nfedge);
void update_triangle_sides_with_fedge(patch *t, segment *e, face *sq, int nT, int xDim, int nsp);
void arrange_spins (voxel *p, patch *t, node *v, int numT, int xDim, int nsp);
void update_node_edge_kind(node *v, segment *fe, isegment *ie, patch *t, int nT, int nfedge);
int assign_new_nodeID (node *v, int ns);
/**
 *
 * @param v
 * @param fe
 * @param ie
 * @param t
 * @param ns
 * @param nN
 * @param nfe
 * @param nie
 * @param nT
 * @param outBaseName
 */
void get_output (node *v, segment *fe, isegment *ie, patch *t, int ns, int nN, int nfe, int nie, int nT,
                 MeshParameters* mp);

}

#endif /* SURFACEMESHGENERALMCABOUNDEDMULTI_H_ */
