/*
 * Your License or Copyright Information can go here
 */

#ifndef SURFACEMESHINGPLUGIN_H_
#define SURFACEMESHINGPLUGIN_H_

#include <QtCore/QObject>
#include <QtCore/QSettings>
#include "QtSupport/DREAM3DPluginInterface.h"


/**
 * @class CMUSurfaceMeshing2Plugin CMUSurfaceMeshing2Plugin.h SurfaceMeshing/CMUSurfaceMeshing2Plugin.h
 * @brief
 * @author Michael A. Jackson for BlueQuartz Software
 * @date May 10, 2012
 * @version 1.0
 */
class CMUSurfaceMeshing2Plugin : public QObject, public DREAM3DPluginInterface
{
    Q_OBJECT;
    Q_INTERFACES(DREAM3DPluginInterface)

  public:
    CMUSurfaceMeshing2Plugin();
    virtual ~CMUSurfaceMeshing2Plugin();
    /**
     * @brief Returns the name of the plugin
     */
    virtual QString getPluginName();

    /**
     * @brief Register all the filters with the FilterWidgetFactory
     */
    virtual void registerFilterWidgets();

    /**
     * @brief Writes the settings in the input gui to the Application's preference file
     * @param prefs A valid QSettings pointer.
     */
    virtual void writeSettings(QSettings &prefs);

    /**
     * @brief Reads the settings from the Application's preference file and sets
     * the input GUI widgets accordingly.
     * @param prefs
     */
    virtual void readSettings(QSettings &prefs);

  private:
    CMUSurfaceMeshing2Plugin(const CMUSurfaceMeshing2Plugin&); // Copy Constructor Not Implemented
    void operator=(const CMUSurfaceMeshing2Plugin&); // Operator '=' Not Implemented
};

#endif /* SURFACEMESHINGPLUGIN_H_ */
